import { ZERO } from '@/constants/common';
import { EntityNumber } from '@/redux/entityNumber/entityNumber.types';
import { BioEntity } from '@/types/models';
import { PinType } from '@/types/pin';
import { UsePointToProjectionResult } from '@/utils/map/usePointToProjection';
import { Feature } from 'ol';
import { getBioEntitySingleFeature } from './getBioEntitySingleFeature';

export const getBioEntitiesFeatures = (
  bioEntites: BioEntity[],
  {
    pointToProjection,
    type,
    entityNumber,
  }: {
    pointToProjection: UsePointToProjectionResult;
    type: PinType;
    entityNumber: EntityNumber;
  },
): Feature[] => {
  return bioEntites.map(bioEntity =>
    getBioEntitySingleFeature(bioEntity, {
      pointToProjection,
      type,
      // pin's index number
      value: entityNumber?.[bioEntity.elementId] || ZERO,
    }),
  );
};
